
; This program will act as LANMAil server on a LAN in any sizes.

; Created by: Danesh Daroui 2004-01-09


.486p
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\wsock32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc
include \masm32\include\winmm.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\wsock32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\winmm.lib

include \masm32\include\shell32.inc
includelib \masm32\lib\shell32.lib


 
include \masm32\include\debug.inc
includelib \masm32\lib\debug.lib

.data
ListeningPort   dd  6677         ; the server will listen to this port by default. This port would specify by user manually
BoxTitle        db  "Server Message", 0
Buff            db  512 dup(0)
                db  0
Buff2           db  "Artemis and Arshak"
                db  0

TextMessage	    DB  "Message 1", 0
OKMsg           db  "Message 2", 0


ThreadID            dd  0
ServerHandle        dd  0
ConnectedClientIP   dd  0
OpenedSocketHandle  dd  0
SockSize            dd  0





.data?
S1        SOCKET ?
S2        SOCKET ?
Sin1      sockaddr_in <>
Sin2      sockaddr_in <>
WSAData   WSADATA <>
Temp      dd ?


.code


AcceptLoop  proc

AcceptConnections:
    Mov Eax, SizeOf sockaddr_in
    Mov SockSize, Eax
    Invoke  accept, S1, Addr Sin2, Addr SockSize

	.If Eax != INVALID_SOCKET			; one connection waits to be served
        Mov OpenedSocketHandle, Eax
	  Mov Eax, Sin2.sin_addr			;get IP address of user
	  Mov ConnectedClientIP, Eax

        Mov Eax, Offset ServeEachConnection
        Invoke  CreateThread, NULL, NULL, Eax, OpenedSocketHandle, NORMAL_PRIORITY_CLASS, Addr ThreadID
	.EndIf

    Jmp AcceptConnections

ret

AcceptLoop endp



ServeEachConnection proc Private OpenedSocketHandleForThisClient:DWord
Local ReceivingBuffer[1000 + 1]:Byte



GetMsgFromClient:					; getting query loop

Invoke  recv, OpenedSocketHandleForThisClient, Addr ReceivingBuffer, 1000, 0

Invoke  send, OpenedSocketHandleForThisClient, Addr TextMessage, SizeOf TextMessage, 0		

Invoke  recv, OpenedSocketHandleForThisClient, Addr ReceivingBuffer, 1000, 0


Invoke  send, OpenedSocketHandleForThisClient, Addr OKMsg, SizeOf OKMsg, 0

Jmp GetMsgFromClient



CloseConnection:
ret

ServeEachConnection endp



start:

invoke  WSAStartup, 0101h, ADDR WSAData
invoke  socket, PF_INET, SOCK_STREAM, 0
mov     S1, eax
mov     ax, AF_INET
mov     Sin1.sin_family, ax
xor     eax, eax
mov     Sin1.sin_addr, eax
invoke  htons, ListeningPort                               ; listen to a specified port
mov     Sin1.sin_port, ax
invoke  bind, S1, ADDR Sin1, SIZEOF sockaddr_in
cmp     eax, SOCKET_ERROR
jne     @F

invoke  WSACleanup
xor     eax, eax
ret


@@:

invoke  listen, S1, 2


    	Mov Eax, Offset AcceptLoop
    	Invoke CreateThread, NULL, NULL, Eax, NULL, NORMAL_PRIORITY_CLASS, Addr ThreadID

    	mov    ServerHandle, eax

ret





end start

